=== modified file 'INSTALL'
--- INSTALL	2009-01-27 00:07:26 +0000
+++ INSTALL	2008-10-28 18:00:20 +0000
@@ -43,14 +43,13 @@
     + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
     + python-ctypes 1.0.0 http://pypi.python.org/pypi/ctypes
-    + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
     
     Strongly recommended:
     + fping 2.4b2-to-ipv6 http://www.fping.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-ctypes python-gobject
+    python-ctypes
    
 *** Mandos Client
     + initramfs-tools 0.85i

=== modified file 'TODO'
--- TODO	2009-01-23 20:09:55 +0000
+++ TODO	2009-01-18 00:16:57 +0000
@@ -1,7 +1,6 @@
 -*- org -*-
 
 * mandos-client
-** TODO [#A] Clean up /tmp directory on signal
 ** TODO [#B] Temporarily lower kernel log level
    for less printouts during sucessfull boot.
    klogctl(6, NULL, 0); klogctl(7, NULL, 0);

=== modified file 'debian/control'
--- debian/control	2009-01-26 23:47:44 +0000
+++ debian/control	2009-01-06 20:39:35 +0000
@@ -15,8 +15,7 @@
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
-	python-avahi, python-gobject, avahi-daemon, gnupg (< 2),
-	adduser
+	python-avahi, avahi-daemon, gnupg (< 2), adduser
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows

=== modified file 'mandos'
--- mandos	2009-01-28 11:23:12 +0000
+++ mandos	2009-01-21 08:10:44 +0000
@@ -595,13 +595,10 @@
         != gnutls.library.constants.GNUTLS_CRT_OPENPGP):
         # ...do the normal thing
         return session.peer_certificate
-    list_size = ctypes.c_uint(1)
+    list_size = ctypes.c_uint()
     cert_list = (gnutls.library.functions
                  .gnutls_certificate_get_peers
                  (session._c_object, ctypes.byref(list_size)))
-    if not bool(cert_list) and list_size.value != 0:
-        raise gnutls.errors.GNUTLSError("error getting peer"
-                                        " certificate")
     if list_size.value == 0:
         return None
     cert = cert_list[0]
@@ -656,108 +653,78 @@
     def handle(self):
         logger.info(u"TCP connection from: %s",
                     unicode(self.client_address))
-        logger.debug(u"Pipe: %d", self.server.pipe[1])
-        # Open IPC pipe to parent process
-        with closing(os.fdopen(self.server.pipe[1], "w", 1)) as ipc:
-            session = (gnutls.connection
-                       .ClientSession(self.request,
-                                      gnutls.connection
-                                      .X509Credentials()))
-            
-            line = self.request.makefile().readline()
-            logger.debug(u"Protocol version: %r", line)
-            try:
-                if int(line.strip().split()[0]) > 1:
-                    raise RuntimeError
-            except (ValueError, IndexError, RuntimeError), error:
-                logger.error(u"Unknown protocol version: %s", error)
-                return
-            
-            # Note: gnutls.connection.X509Credentials is really a
-            # generic GnuTLS certificate credentials object so long as
-            # no X.509 keys are added to it.  Therefore, we can use it
-            # here despite using OpenPGP certificates.
-            
-            #priority = ':'.join(("NONE", "+VERS-TLS1.1",
-            #                     "+AES-256-CBC", "+SHA1",
-            #                     "+COMP-NULL", "+CTYPE-OPENPGP",
-            #                     "+DHE-DSS"))
-            # Use a fallback default, since this MUST be set.
-            priority = self.server.settings.get("priority", "NORMAL")
-            (gnutls.library.functions
-             .gnutls_priority_set_direct(session._c_object,
-                                         priority, None))
-
-            try:
-                session.handshake()
-            except gnutls.errors.GNUTLSError, error:
-                logger.warning(u"Handshake failed: %s", error)
-                # Do not run session.bye() here: the session is not
-                # established.  Just abandon the request.
-                return
-            logger.debug(u"Handshake succeeded")
-            try:
-                fpr = fingerprint(peer_certificate(session))
-            except (TypeError, gnutls.errors.GNUTLSError), error:
-                logger.warning(u"Bad certificate: %s", error)
-                session.bye()
-                return
-            logger.debug(u"Fingerprint: %s", fpr)
-            for c in self.server.clients:
-                if c.fingerprint == fpr:
-                    client = c
-                    break
-            else:
-                logger.warning(u"Client not found for fingerprint: %s",
-                               fpr)
-                ipc.write("NOTFOUND %s\n" % fpr)
-                session.bye()
-                return
-            # Have to check if client.still_valid(), since it is
-            # possible that the client timed out while establishing
-            # the GnuTLS session.
-            if not client.still_valid():
-                logger.warning(u"Client %(name)s is invalid",
-                               vars(client))
-                ipc.write("INVALID %s\n" % client.name)
-                session.bye()
-                return
-            ipc.write("SENDING %s\n" % client.name)
-            ## This won't work here, since we're in a fork.
-            # client.checked_ok()
-            sent_size = 0
-            while sent_size < len(client.secret):
-                sent = session.send(client.secret[sent_size:])
-                logger.debug(u"Sent: %d, remaining: %d",
-                             sent, len(client.secret)
-                             - (sent_size + sent))
-                sent_size += sent
-            session.bye()
-
-
-class ForkingMixInWithPipe(SocketServer.ForkingMixIn, object):
-    """Like SocketServer.ForkingMixIn, but also pass a pipe.
-    Assumes a gobject.MainLoop event loop.
-    """
-    def process_request(self, request, client_address):
-        """This overrides and wraps the original process_request().
-        This function creates a new pipe in self.pipe 
-        """
-        self.pipe = os.pipe()
-        super(ForkingMixInWithPipe,
-              self).process_request(request, client_address)
-        os.close(self.pipe[1])  # close write end
-        # Call "handle_ipc" for both data and EOF events
-        gobject.io_add_watch(self.pipe[0],
-                             gobject.IO_IN | gobject.IO_HUP,
-                             self.handle_ipc)
-    def handle_ipc(source, condition):
-        """Dummy function; override as necessary"""
-        os.close(source)
-        return False
-
-
-class IPv6_TCPServer(ForkingMixInWithPipe,
+        session = (gnutls.connection
+                   .ClientSession(self.request,
+                                  gnutls.connection
+                                  .X509Credentials()))
+        
+        line = self.request.makefile().readline()
+        logger.debug(u"Protocol version: %r", line)
+        try:
+            if int(line.strip().split()[0]) > 1:
+                raise RuntimeError
+        except (ValueError, IndexError, RuntimeError), error:
+            logger.error(u"Unknown protocol version: %s", error)
+            return
+        
+        # Note: gnutls.connection.X509Credentials is really a generic
+        # GnuTLS certificate credentials object so long as no X.509
+        # keys are added to it.  Therefore, we can use it here despite
+        # using OpenPGP certificates.
+        
+        #priority = ':'.join(("NONE", "+VERS-TLS1.1", "+AES-256-CBC",
+        #                "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
+        #                "+DHE-DSS"))
+        # Use a fallback default, since this MUST be set.
+        priority = self.server.settings.get("priority", "NORMAL")
+        (gnutls.library.functions
+         .gnutls_priority_set_direct(session._c_object,
+                                     priority, None))
+        
+        try:
+            session.handshake()
+        except gnutls.errors.GNUTLSError, error:
+            logger.warning(u"Handshake failed: %s", error)
+            # Do not run session.bye() here: the session is not
+            # established.  Just abandon the request.
+            return
+        try:
+            fpr = fingerprint(peer_certificate(session))
+        except (TypeError, gnutls.errors.GNUTLSError), error:
+            logger.warning(u"Bad certificate: %s", error)
+            session.bye()
+            return
+        logger.debug(u"Fingerprint: %s", fpr)
+        for c in self.server.clients:
+            if c.fingerprint == fpr:
+                client = c
+                break
+        else:
+            logger.warning(u"Client not found for fingerprint: %s",
+                           fpr)
+            session.bye()
+            return
+        # Have to check if client.still_valid(), since it is possible
+        # that the client timed out while establishing the GnuTLS
+        # session.
+        if not client.still_valid():
+            logger.warning(u"Client %(name)s is invalid",
+                           vars(client))
+            session.bye()
+            return
+        ## This won't work here, since we're in a fork.
+        # client.checked_ok()
+        sent_size = 0
+        while sent_size < len(client.secret):
+            sent = session.send(client.secret[sent_size:])
+            logger.debug(u"Sent: %d, remaining: %d",
+                         sent, len(client.secret)
+                         - (sent_size + sent))
+            sent_size += sent
+        session.bye()
+
+
+class IPv6_TCPServer(SocketServer.ForkingMixIn,
                      SocketServer.TCPServer, object):
     """IPv6 TCP server.  Accepts 'None' as address and/or port.
     Attributes:
@@ -815,39 +782,6 @@
             return super(IPv6_TCPServer, self).server_activate()
     def enable(self):
         self.enabled = True
-    def handle_ipc(self, source, condition, file_objects={}):
-        logger.debug("Handling IPC: %r : %r", source, condition)
-        
-        # Turn a file descriptor into a Python file object
-        if source not in file_objects:
-            file_objects[source] = os.fdopen(source, "r", 1)
-        
-        # Read a line from the file object
-        cmdline = file_objects[source].readline()
-        if not cmdline:             # Empty line means end of file
-            # close the IPC pipe
-            logger.debug("Closing: %r", source)
-            file_objects[source].close()
-            del file_objects[source]
-
-            # Stop calling this function
-            return False
-        
-        logger.debug("IPC command: %r\n" % cmdline)
-        
-        # Parse and act on command
-        cmd, args = cmdline.split(None, 1)
-        if cmd == "NOTFOUND":
-            pass                # xxx
-        elif cmd == "INVALID":
-            pass                # xxx
-        elif cmd == "SENDING":
-            pass                # xxx
-        else:
-            logger.error("Unknown IPC command: %r", cmdline)
-        
-        # Keep calling this function
-        return True
 
 
 def string_to_delta(interval):
@@ -1007,14 +941,11 @@
     server_config.read(os.path.join(options.configdir, "mandos.conf"))
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
-    # Use the appropriate methods on the non-string config options
-    server_settings["debug"] = server_config.getboolean("DEFAULT",
-                                                        "debug")
-    server_settings["use_dbus"] = server_config.getboolean("DEFAULT",
-                                                           "use_dbus")
-    if server_settings["port"]:
-        server_settings["port"] = server_config.getint("DEFAULT",
-                                                       "port")
+    # Use getboolean on the boolean config options
+    server_settings["debug"] = (server_config.getboolean
+                                ("DEFAULT", "debug"))
+    server_settings["use_dbus"] = (server_config.getboolean
+                                   ("DEFAULT", "use_dbus"))
     del server_config
     
     # Override the settings from the config file with command line
@@ -1179,12 +1110,10 @@
             
             @dbus.service.method(_interface, out_signature="ao")
             def GetAllClients(self):
-                "D-Bus method"
                 return dbus.Array(c.dbus_object_path for c in clients)
             
             @dbus.service.method(_interface, out_signature="a{oa{sv}}")
             def GetAllClientsWithProperties(self):
-                "D-Bus method"
                 return dbus.Dictionary(
                     ((c.dbus_object_path, c.GetAllProperties())
                      for c in clients),
@@ -1192,7 +1121,6 @@
             
             @dbus.service.method(_interface, in_signature="o")
             def RemoveClient(self, object_path):
-                "D-Bus method"
                 for c in clients:
                     if c.dbus_object_path == object_path:
                         clients.remove(c)

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2009-01-27 15:42:41 +0000
+++ plugins.d/mandos-client.c	2009-01-14 14:20:17 +0000
@@ -36,8 +36,7 @@
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
 
 #include <stdio.h>		/* fprintf(), stderr, fwrite(),
-				   stdout, ferror(), sscanf(),
-				   remove() */
+				   stdout, ferror(), sscanf */
 #include <stdint.h> 		/* uint16_t, uint32_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, EXIT_FAILURE,
@@ -154,7 +153,7 @@
   
   
   /*
-   * Helper function to insert pub and seckey to the engine keyring.
+   * Helper function to insert pub and seckey to the enigne keyring.
    */
   bool import_key(const char *filename){
     int fd;
@@ -832,7 +831,6 @@
     gid_t gid;
     char *connect_to = NULL;
     char tempdir[] = "/tmp/mandosXXXXXX";
-    bool tempdir_created = false;
     AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
     const char *seckey = PATHDIR "/" SECKEY;
     const char *pubkey = PATHDIR "/" PUBKEY;
@@ -840,8 +838,8 @@
     mandos_context mc = { .simple_poll = NULL, .server = NULL,
 			  .dh_bits = 1024, .priority = "SECURE256"
 			  ":!CTYPE-X.509:+CTYPE-OPENPGP" };
-    bool gnutls_initialized = false;
-    bool gpgme_initialized = false;
+    bool gnutls_initalized = false;
+    bool gpgme_initalized = false;
     
     {
       struct argp_option options[] = {
@@ -977,28 +975,27 @@
       exitcode = EXIT_FAILURE;
       goto end;
     } else {
-      gnutls_initialized = true;
+      gnutls_initalized = true;
     }
     
     if(mkdtemp(tempdir) == NULL){
       perror("mkdtemp");
+      tempdir[0] = '\0';
       goto end;
     }
-    tempdir_created = true;
     
     if(not init_gpgme(&mc, pubkey, seckey, tempdir)){
-      fprintf(stderr, "init_gpgme failed\n");
+      fprintf(stderr, "gpgme_initalized failed\n");
       exitcode = EXIT_FAILURE;
       goto end;
     } else {
-      gpgme_initialized = true;
+      gpgme_initalized = true;
     }
     
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
       fprintf(stderr, "No such interface: \"%s\"\n", interface);
-      exitcode = EXIT_FAILURE;
-      goto end;
+      exit(EXIT_FAILURE);
     }
     
     if(connect_to != NULL){
@@ -1108,18 +1105,18 @@
     if(mc.simple_poll != NULL)
         avahi_simple_poll_free(mc.simple_poll);
     
-    if(gnutls_initialized){
+    if(gnutls_initalized){
       gnutls_certificate_free_credentials(mc.cred);
       gnutls_global_deinit();
       gnutls_dh_params_deinit(mc.dh_params);
     }
     
-    if(gpgme_initialized){
+    if(gpgme_initalized){
       gpgme_release(mc.ctx);
     }
     
     /* Removes the temp directory used by GPGME */
-    if(tempdir_created){
+    if(tempdir[0] != '\0'){
       DIR *d;
       struct dirent *direntry;
       d = opendir(tempdir);
@@ -1133,26 +1130,21 @@
 	  if(direntry == NULL){
 	    break;
 	  }
-	  /* Skip "." and ".." */
-	  if(direntry->d_name[0] == '.'
-	     and (direntry->d_name[1] == '\0'
-		  or (direntry->d_name[1] == '.'
-		      and direntry->d_name[2] == '\0'))){
-	    continue;
-	  }
-	  char *fullname = NULL;
-	  ret = asprintf(&fullname, "%s/%s", tempdir,
-			 direntry->d_name);
-	  if(ret < 0){
-	    perror("asprintf");
-	    continue;
-	  }
-	  ret = remove(fullname);
-	  if(ret == -1){
-	    fprintf(stderr, "remove(\"%s\"): %s\n", fullname,
-		    strerror(errno));
-	  }
-	  free(fullname);
+	  if(direntry->d_type == DT_REG){
+	    char *fullname = NULL;
+	    ret = asprintf(&fullname, "%s/%s", tempdir,
+			   direntry->d_name);
+	    if(ret < 0){
+	      perror("asprintf");
+	      continue;
+	    }
+	    ret = unlink(fullname);
+	    if(ret == -1){
+	      fprintf(stderr, "unlink(\"%s\"): %s",
+		      fullname, strerror(errno));
+	    }
+	    free(fullname);
+	  }
 	}
 	closedir(d);
       }
@@ -1161,6 +1153,6 @@
 	perror("rmdir");
       }
     }
-    
+	  
     return exitcode;
 }

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2009-01-24 15:26:43 +0000
+++ plugins.d/mandos-client.xml	2009-01-04 21:54:55 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2009-01-24">
+<!ENTITY TIMESTAMP "2009-01-04">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -122,16 +122,11 @@
       <command>&COMMANDNAME;</command> is a client program that
       communicates with <citerefentry><refentrytitle
       >mandos</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      to get a password.  In slightly more detail, this client program
-      brings up a network interface, uses the interface’s IPv6
-      link-local address to get network connectivity, uses Zeroconf to
-      find servers on the local network, and communicates with servers
-      using TLS with an OpenPGP key to ensure authenticity and
-      confidentiality.  This client program keeps running, trying all
-      servers on the network, until it receives a satisfactory reply
-      or a TERM signal is received.  If no servers are found, or after
-      all servers have been tried, it waits indefinitely for new
-      servers to appear.
+      to get a password.  It uses IPv6 link-local addresses to get
+      network connectivity, Zeroconf to find servers, and TLS with an
+      OpenPGP key to ensure authenticity and confidentiality.  It
+      keeps running, trying all servers on the network, until it
+      receives a satisfactory reply or a TERM signal is received.
     </para>
     <para>
       This program is not meant to be run directly; it is really meant
@@ -206,15 +201,6 @@
 	    specifies the interface to use to connect to the address
 	    given.
 	  </para>
-	  <para>
-	    Note that since this program will normally run in the
-	    initial RAM disk environment, the interface must be an
-	    interface which exists at that stage.  Thus, the interface
-	    can not be a pseudo-interface such as <quote>br0</quote>
-	    or <quote>tun0</quote>; such interfaces will not exist
-	    until much later in the boot process, and can not be used
-	    by this program.
-	  </para>
 	</listitem>
       </varlistentry>
       

